#pragma once
//1.1命题符号化
#include <iostream>
#include <string>

using namespace std;

#define Statement string

/**
 * 1、命题是具有惟一真、假值的陈述句
 * 2、真为1，假为0
 * 3、若一个命题是一个简单陈述句，则称之为简单命题
 * 4、由简单命题通过"非"、"或"、"与"、"蕴含"以及"等值"这些命题联结词而组成的命题称为复合命题
 * 5、双条件命题（等值表达式）
*/

//非
Statement Non(Statement p)
{
	return "非" + p;
}
//合取
Statement Conjunction(Statement p, Statement q)
{
	return p + "并且" + q;
}
//析取
Statement Disjunctive(Statement p, Statement q)
{
	return p + "或者" + q;
}
//蕴含
Statement Imp(Statement p, Statement q)
{
	return "若" + p + "则" + q;
}
//等值
Statement Equivalence(Statement p, Statement q)
{
	return p + "当且仅当" + q;
}